module OrientDb
  class CollectionRepository < Base
    include OrientDb::Methods::EdgeMethods

    def all
      hash = connection.query "SELECT FROM Collection"
      collections = build_collections(hash)
    end

    # Usage:
    #   collection = repository.for(:collections).find '#14:14'
    def find(id)
      result = connection.query "SELECT FROM #{id}"
      build_collection result.first
    end

    # Usage:
    #   repository.for(:collections).destroy collection
    #
    def destroy(collection)
      connection.command sprintf("DELETE VERTEX %s", collection.id)
    end

    private

    def build_collection(args={})
      Collection.new(
          :id => args["@rid"],
          :name => args["name"]
      )
    end

    def build_collections(hash=[])
      collections = []
      hash.each do |h|
        collections << build_collection(h)
      end

      collections
    end

  end
end
